﻿using ApplicationAvalonia.Utilities;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using MsBox.Avalonia;
using MsBox.Avalonia.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ApplicationAvalonia.ViewModels
{
    internal partial class AuthViewModel : ViewModelBase
    {
        PageSwitcher pgSwitch;
        public AuthViewModel(ref PageSwitcher pgSwitch)
        {
            // There we get the reference of the object navigation
            this.pgSwitch = pgSwitch;            
        }

        [ObservableProperty]
        private string _login = string.Empty;

        [ObservableProperty]
        private string _password = string.Empty;

        [ObservableProperty]
        private string _message = string.Empty;


        [RelayCommand]
        private async void ButtonClick()
        {
            Message = string.Empty; // Reset the past message

            if (Password == "" || Login == "")
            {
                if (Password == Login)
                {
                    // both empty
                    Message = "Заполните поле логина и пароля";
                    return;
                }
                else
                {
                    if (Login == "")
                        Message = "Заполните поле логина";

                    if (Password == "")
                        Message = "Заполните поле пароля";

                    return;
                }
            }
            else
            {
                var user = dbContext.LoginTables.SingleOrDefault(x => x.Login == Login);

                if (user == null)
                {
                    Message = "Пользователя с таким логином не существует в базе данных";
                    return;
                }

                string password = EncryptionClass.Decrypt(user.Password, user.Key, user.Iv);

                if (Password == password)
                {

                    var box = MessageBoxManager.GetMessageBoxStandard("Сообщение для вас", "Авторизация прошла успешно", 
                        ButtonEnum.Ok, Icon.Success);

                    var result = await box.ShowAsync();

                    this.pgSwitch.View = new HomeViewModel(ref pgSwitch);

                    
                    var logTable = dbContext.UserTables.SingleOrDefault(x => x.IdLogin == user.Id);

                    if (logTable != null)
                    {
                        user.UserTable = logTable;
                    }

                    currentUser = user;

                    return;
                }

                Message = "Пароль введён не верно";
            }

        }

        [RelayCommand]
        private void RegBtn()
        {
            this.pgSwitch.View = new RegestViewModel(ref pgSwitch);
        }

    }
}
