﻿using ApplicationAvalonia.Models;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ApplicationAvalonia.ViewModels
{
    internal partial class InfoFilmViewModel : ViewModelBase
    {
        PageSwitcher pgSwitch;

        [ObservableProperty]
        private Film? _film = null;

        [ObservableProperty]
        private string _directorsAll = string.Empty;

        public InfoFilmViewModel(ref PageSwitcher pageSwitcher, Film film)
        {
            this.pgSwitch = pageSwitcher;
            Film = film;

            var directors = Film.DirectorsAndFilms;

            string allDirectors = string.Empty;

            foreach (var director in directors)
            {
                var fullName = director.IdDirectorNavigation.Name + " " + director.IdDirectorNavigation.Surname;
                allDirectors += fullName + ", ";
            }

            char[] charsToTrim = { ' ', ',' };

            allDirectors = allDirectors.TrimEnd(charsToTrim);

            DirectorsAll = allDirectors;
        }

        [RelayCommand]
        private void GoBackToHome()
        {
            this.pgSwitch.View = new HomeViewModel(ref pgSwitch);
        }


    }
}
