﻿using ApplicationAvalonia.Models;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Security.Cryptography;
using ApplicationAvalonia.Utilities;

namespace ApplicationAvalonia.ViewModels
{
    internal partial class PersonalCabinetViewModel : ViewModelBase
    {
        PageSwitcher pgSwitch;


        [ObservableProperty]
        private LoginTable _user;

        [ObservableProperty]
        private string _newPaswword = string.Empty;

        public PersonalCabinetViewModel(ref PageSwitcher pageSwitcher)
        {
            this.pgSwitch = pageSwitcher;

            if(currentUser != null)
            {
                User = currentUser;
            }
        }

        [RelayCommand]
        private async void EditProfile()
        {

            if (User.Login != string.Empty && User.UserTable.UserName != string.Empty 
                && User.UserTable.UserSurname != string.Empty && NewPaswword != string.Empty)
            {
                byte[] key = new byte[16];
                byte[] iv = new byte[16];
                
                using (RandomNumberGenerator rng = RandomNumberGenerator.Create())
                {
                    rng.GetBytes(key);
                    rng.GetBytes(iv);
                }
                
                byte[] encryptedPassword = EncryptionClass.Encrypt(NewPaswword, key, iv);

                User.Iv = iv;
                User.Key = key;
                User.Password = encryptedPassword;

                dbContext.LoginTables.Update(User);
                dbContext.SaveChanges();

                var box = MessageBoxManager.GetMessageBoxStandard("Сообщение", "Данные обновлены", ButtonEnum.Ok, Icon.Success);

                var result = await box.ShowAsync();
            }
            else
            {
                var box = MessageBoxManager.GetMessageBoxStandard("Сообщение", "Заполните поля",
                 ButtonEnum.Ok, Icon.Error);

                var result = await box.ShowAsync();
            }


        }



        [RelayCommand]
        private void GoBack()
        {
            this.pgSwitch.View = new HomeViewModel(ref pgSwitch);
        }

        [RelayCommand]
        private void Exit() 
        {
            currentUser = null;
            this.pgSwitch.View = new AuthViewModel(ref pgSwitch);
        }


    }
}
